package learning.bigdata.custom;

import org.apache.hadoop.io.Text;
import org.apache.hadoop.io.WritableComparable;
import org.apache.hadoop.io.WritableComparator;

/**
 * 
 * @author amar
 *
 */
public class KeyFieldsComparator extends WritableComparator {
	protected KeyFieldsComparator() {
		super(Text.class, true);
	}	
	@SuppressWarnings("rawtypes")
	@Override
	public int compare(WritableComparable w1, WritableComparable w2) {

		Text key1 = (Text) w1;
		Text key2 = (Text) w2;

		// Get the fields of the key
		String keyString1 = key1.toString();
		String[] keyFields1 = keyString1.split("-");

		String keyString2 = key2.toString();
		String[] keyFields2 = keyString2.split("-");
		
		// (compare on the second part of the key)
		int compare = keyFields1[1].compareTo(keyFields2[1]);

		return compare;
	}
}
